<?php
/*
  Plugin Name: Advanced Tagline
  Plugin URI: http://kmorey.net/downloads/advanced-tagline-wordpress-plugin
  Description: This plugin gives the option to have multiple taglines for your blog and display them at random or sequentially with each page view
  Author: Kevin Morey
  Version: 1.4
  Author URI: http://kmorey.net
  
  ==
  Copyright 2008  Kevin Morey  (email : kevin@kmorey.net)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
?>
<div class="advtag_wrap">
  <h2>Advanced Tagline <?php print ADVTAG_VERSION; ?></h2>
  
  <?php if (!empty($message)) { ?>
  <div id="message" class="<?php if($error) { print "error"; } else { print "updated"; }?>">
    <?php echo $message; ?>
  </div>
  <?php } ?>
  
  <div id="changes_alert" style="display: none;">
    <p>Changes have been made and will not be applied until you save!</p>
  </div>
  
  <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
  
    <div id="accordion">
    
      <h3 class="toggler">Tagline Type</h3>
      <div class="element">
        <input id="sequential" type="radio" name="rotate_type" value="sequential" <? if($advtag_type == "sequential") { print " checked "; } ?> /><label for="sequential">Sequential - each tagline will be displayed in order, with the next one displaying when the page refreshes</label><br />
        <input id="random" type="radio" name="rotate_type" value="random" <? if($advtag_type != "sequential") { print " checked "; } ?> /><label for="random">Random - a tagline will be randomly selected and displayed with each page refresh</label><br />
      </div>
      
      <h3 class="toggler">Add Tagline</h3>
      <div class="element" id="add_tagline">
        <table>
          <thead>
            <tr><td>Text</td><td>Link</td><td colspan="2">Target</td></tr>
          </thead>
          <tbody>
            <tr><td>
              <input type="text" id="add_text" size="50" />
            </td><td>
              <input type="text" id="add_link" size="50" />
            </td><td>
              <input type="text" id="add_target" size="15" />
            </td><td>
              <input class="button" type="button" value="Add" onClick="advtag_addTagline();" />
            </td></tr>
          </tbody>
        </table>
      </div>
    
      <h3 class="toggler">Active Taglines</h3>
      <div class="element">
        <p>These taglines will be active and will appear in the rotation upon save.</p>
        <table>
          <thead style="display: none;">
            <tr><td colspan="2" /><td>Text</td><td>Link</td><td>Target</td><td /></tr>
          </thead>
          <tbody id='active_taglines'>
          </tbody>
        </table>
      </div>
      
      <h3 class="toggler">Removed Taglines</h3>
      <div class="element">
        <p>These taglines will be permanently removed upon save.</p>
        <table>
          <thead style="display: none;">
            <tr><td colspan="2" /><td>Text</td><td>Link</td><td>Target</td><td /></tr>
          </thead>
          <tbody id="removed_taglines">
          </tbody>
        </table>
      </div>
    </div>
    
    <p class="submit">    
      <input type="submit" name="save" value="<?php _e('Save Changes', 'advtag') ?>" onClick="advtag_purgeRemoved();" />
      <input type="button" value="<?php _e('Cancel Changes', 'advtag') ?>" onClick="window.location='<?php print $_SERVER["REQUEST_URI"]; ?>'" />
    </p>
  </form>
  
  <h3>Import</h3>
  <p>NOTE: Be sure to save your changes before doing a batch import. It will not save for you.</p>
  <form enctype="multipart/form-data" action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="POST">
    <!-- MAX_FILE_SIZE must precede the file input field -->
    <input type="hidden" name="MAX_FILE_SIZE" value="30000" />
  
    <input id="import_replace" type="radio" name="import_type" value="replace" /><label for="import_replace">Replace Existing</label><br />
    <input id="import_append" type="radio" name="import_type" value="append" checked /><label for="import_append">Append to Existing</label><br />
  
    <!-- Name of input element determines name in $_FILES array -->
    <strong>Import File</strong> <input name="importfile" type="file" /><br />
    <p class="submit">
      <input type="submit" name="import" value="Perform Import" />
      <input type="reset" value="Cancel Import" />
    </p>
  </form>
  
  <?php/*
  <h3>Export</h3>
  <form action="/wp-content/plugins/advanced-tagline/export.php" method="POST">
  <p>NOTE: Be sure to save your changes before doing a batch import. It will not save for you.</p>
    <input id="export_csv" type="radio" name="export_type" value="csv" /><label for="export_csv">CSV</label><br />
    
    <input class="button" type="submit" name="export" value="Export" />
  </form>
  */?>

</div>
